	device zxspectrum48
;        ORG #4000
; incbin "sudoku2.scr"
        ORG #6000
begin
	ld sp,$5FFF
	call blackscr
	ld hl,song:call INIT
	
	di
	ld hl,$be00
	ld de,$be01
	ld bc,257
	ld (hl),$BF
	ld a,h
	ldir
	ld i,a
	im 2
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFBF+1),hl
	ei

;print title
	ld ix,m1,de,$4826
	call tout

	ld ix,m2,de,$4823+64-1
	call tout

	ld ix,m3,de,$484A+96
	call tout
	
wk: xor a:in a,($FE):cpl:and 31:jr z,wk
	call blackscr
	ld hl,ppic,de,$4000
	call dzx7_standard
nwk: xor a:in a,($FE):cpl:and 31:jr nz,nwk

	call print_board
	
	ld de,0
	ld (pxy),de
	call cursor
;	jr $
;----------------------------------------------------------------------------------------------------
rept_delay equ 2; delay with repeat
def_delay equ 5
;	ld hl,$5800:set 6,(hl)
	ld de,0 ; D.E=y.x
dl: ld b,rept_delay
ww:	ei:halt
	djnz ww
;test keys
; 4
;123
	ld a,$F7 ; right
	in a,($FE)
	and 16
	jr nz, keyl
	ld hl,prevkey
	ld a,1
	ld c,def_delay
	cp (hl)
	ld (hl),a
	jr nz, nokeyr
	ld c,rept_delay
nokeyr: ; proceed
	ld a,c,(dl+1),a
	
	inc e
	dec e
	jp z,dl
	call cursor
	dec e
	call cursor
	ei:halt:halt
	jp dl
keyl:
	ld a,$EF ; left
	in a,($FE)
	and 4
	jr nz, keyd
	ld hl,prevkey
	ld a,3
	ld c,def_delay
	cp (hl)
	ld (hl),a
	jr nz, nokeyl
	ld c,rept_delay
nokeyl: ; proceed
	ld a,c,(dl+1),a
	ld a,e
	cp 8
	jp z,dl
	call cursor
	inc e
	call cursor
	ei:halt:halt
	jp dl
keyd:
	ld a,$EF ; 6-down
	in a,($FE)
	and 16
	jr nz, keyu
	ld hl,prevkey
	ld a,2
	ld c,def_delay
	cp (hl)
	ld (hl),a
	jr nz, nokeyd
	ld c,rept_delay
nokeyd: ; proceed
	ld a,c,(dl+1),a
	ld a,d
	cp 8
	jp z,dl
	call cursor
	inc d
	call cursor
	ei:halt:halt
	jp dl
keyu:
	ld a,$EF ; 7-up
	in a,($FE)
	and 8
	jr nz, key_end
	ld hl,prevkey
	ld a,4
	ld c,def_delay
	cp (hl)
	ld (hl),a
	jr nz, nokeyu
	ld c,rept_delay
nokeyu: ; proceed
	ld a,c,(dl+1),a
	inc d
	dec d
	jp z,dl
	call cursor
	dec d
	call cursor
	ei:halt:halt
	jp dl
key_end:
	push de
	call ks
	pop de
	ld hl,validk
	ld b,9+1
cpklp: cp (hl)
	jr z,excp
	inc hl
	djnz cpklp
	jp dl
excp: ; put char to board map
	push de
	ld l,d,h,0,d,h
	ld bc,hl
	add hl,hl;*2
	add hl,bc;*3
	ld bc,hl
	add hl,hl
	add hl,bc
	add hl,de
	ld bc,board
	add hl,bc
;	jr $
	ld (hl),a
	pop de
	call putchar
;check is solved
	ld hl,solution
	ld ix,board
	ld b,81
checkol
	ld a,(hl)
	and 127
	cp (ix+0)
	jp nz,dl
	inc hl,ix
	djnz checkol
;draw word
finish:
	ld hl,wdspr
	ld de,$5406+5*32
	ld bc,$1014
drsprl:
	push de,bc
	ld b,0
	ldir
	pop bc,de
	ex de,hl
	call nbhl
	ex de,hl
	djnz drsprl

sca:
	ld ix,$5a06+5*32
cpo: ld hl,catr
agai: ld a,(hl)
	inc hl
	cp $FF
	jr nz,nolpcol
	ld hl,catr
	jr agai
nolpcol:
	ld (cpo+1),hl
	or $38
	ld (ix+20),a
	ld (ix+21),a
	ld (ix+52),a
	ld (ix+53),a
	ld (ix+84),a
	ld (ix+85),a

	ld b,11
	ei:halt:halt:halt:halt:halt
movlp:
	ld a,(ix+2),(ix+0),a
	ld a,(ix+3),(ix+1),a

	ld a,(ix+34),(ix+32),a
	ld a,(ix+35),(ix+33),a

	ld a,(ix+66),(ix+64),a
	ld a,(ix+67),(ix+65),a

	inc ix,ix
	djnz movlp
	jp sca
catr:
	db 0,1,5,4,6,5,4,1
	db $FF

;	jr $
;
validk: db "AEHNOPRWY "
;----------------------------------------------------------------------------------------------------
ks:
		ld	ix, chartab
		ld	l, 8;key pars count
		ld	bc, $FEFE

kslp:
		ld	e, 1
		ld	d, 5

rowkey:
		in	a, (c)
		and	e
		jr	nz, nokey
		ld a,(ix+0)
		ret
nokey:
		sla	e
		inc	ix
		dec	d
		jr	nz, rowkey
		rlc	b
		dec	l
		jr	nz, kslp
		xor a
		ret
chartab
	db $0B,"ZXCV"
	db "ASDFG"
	db "QWERT"
	db "12345"
	db "09876"
	db "POIUY"
	db $0D,"LKJH"
	db 32,$0C,"MNB"

;----------------------------------------------------------------------------------------------------
;012345670123456701234567
;ooooooppppppqqqqqqeeeeee
;........ ....... .......
tout:
	ld a,7,(patr+1),a
	push de
	exx
	pop hl
;$40=01 000 000 $58=01011 000
;$48=01 001 000 $59=01011 001
;$50=01 010 000 $5A=01011 010
	ld a,h
	srl a
	srl a
	srl a
	and 7
	add a,$58
	ld h,a
	exx
tlp:
gc1: ld a,(ix+0):inc ix
	cp $FF:ret z
	cp 8:jr nc, pc1
	ld(patr+1),a:jr gc1
pc1
	ld l,a,h,0,bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
;1
	push de
chlp1:
	ld b,(hl),c,0:inc hl
	ld a,b,(de),a:inc e
	ld a,c,(de),a:dec e
	inc d
	ld a,d
	and 7
	jr nz,chlp1
	pop de
;2
gc2:	ld a,(ix+0):inc ix
	cp $FF:ret z
	cp 8:jr nc, pc2
	ld(patr+1),a:jr gc2
pc2

	ld l,a,h,0,bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc

	push de
chlp2:
	ld b,(hl),c,0:inc hl
	ld a,6:call shrn
	ld a,(de):or b:ld (de),a:inc e
	ld a,c:ld (de),a:dec e
	inc d
	ld a,d
	and 7
	jr nz,chlp2
	pop de
	inc e
	call puta
;3
gc3:	ld a,(ix+0):inc ix
	cp $FF:ret z
	cp 8:jr nc, pc3
	ld(patr+1),a:jr gc3
pc3

	ld l,a,h,0,bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	push de
chlp3:
	ld b,(hl),c,0:inc hl
	ld a,4:call shrn
	ld a,(de):or b:ld (de),a:inc e
	ld a,c:ld (de),a:dec e
	inc d
	ld a,d
	and 7
	jr nz,chlp3
	pop de
	inc e
	call puta
;4
gc4:	ld a,(ix+0):inc ix
	cp $FF:ret z
	cp 8:jr nc, pc4
	ld(patr+1),a:jr gc4
pc4
	ld l,a,h,0,bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc

	push de
chlp4:
	ld b,(hl),c,0:inc hl
	ld a,2:call shrn
	ld a,(de):or b:ld (de),a
	inc d
	ld a,d
	and 7
	jr nz,chlp4
	pop de
	inc e
	call puta
	jp tlp
puta:
	exx
patr: ld (hl),7:inc hl
	exx
	ret
shrn: ; shift BC right, A=n times
	srl b:rr c
	dec a:jr nz,shrn
	ret
m1:
 db "Sudoku NY, ",4,"g0blinish ",7,"2023 "
 db $FF
m2:
 db "Solve puzzle with ",5,"A,E,H,N,O,P,R,W,Y "
 db $FF
m3:
 db "Press ",6,"Any Key "
 db $FF

;----------------------------------------------------------------------------------------------------
print_board:
	ld hl,board
	ld d,0
prylp:
	ld e,0
prxlp:
	ld a,(hl)
	inc hl
	cp $20
	call nz,putchar
	inc e
	ld a,e
	cp 9
	jr nz,prxlp

	inc d
	ld a,d
	cp 9
	jr nz,prylp
	ret

putchar:
	push af,bc,de,hl
;	ld a,"A"
;	ld hl,$4000+7+3*32
	call charxy
	push hl
	ld l,a
	ld h,0
	ld bc,fnt-256+1
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	push hl
	pop ix ; ix=font
	ld c,5
	pop hl ; hl=address
	call nbhl
	call nbhl
	call nbhl
fylp:
	ld b,8
	ld a,(ix+0)
	inc ix
	ld de,0
fxlp:
	add a,a
	push af
	sbc a,a
	and 3
	ex de,hl
	add hl,hl
	add hl,hl
	or l
	ld l,a
	ex de,hl
	pop af
	djnz fxlp
	or a
	rr d
	rr e

	or a
	rr d
	rr e

	ld (hl),d:inc l
	ld a,(hl):and 1:or e:ld (hl),a
	call nbhl
	ld a,(hl):and 1:or e:ld (hl),a
	dec l:ld (hl),d
	call nbhl
	dec c
	jr nz,fylp
	pop hl,de,bc,af
	ret

charxy:
	push af
	call map2real
	ld	hl, 4000h
	ld	a, d
	and	18h
	or	h
	ld	h, a
	ld	a, d
	and	7
	ld	d, a
	srl	d
	rr	l
	srl	d
	rr	l
	srl	d
	rr	l
	add	hl, de
	pop af
	ret
map2real:
	push af
	ld a,d
	add a,a
	add a,3
	ld d,a

	ld a,e
	add a,a
	add a,7
	ld e,a

	pop af
	ret

cursor
	push af,de,hl,ix
	call map2real
	ld l,d,h,0,d,h
	add hl,hl
	add hl,hl
	ld h,11
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	push hl
	pop ix
	ld a,(ix+0):xor 64:ld (ix+0),a
	ld a,(ix+1):xor 64:ld (ix+1),a
	ld a,(ix+32):xor 64:ld (ix+32),a
	ld a,(ix+33):xor 64:ld (ix+33),a
	pop ix,hl,de,af
	ret

blackscr    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr:ret

nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

intvec:
	push ix
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop ix
	ei:ret

zx7:include "zx7.a80"
;----------------------- vars & data -----------------------
ppic:incbin "sudoku22.scr.zx7"
pxy:dw 0
prevkey:db 0

board:
 db "H    W  Y"
 db " A  H P  "
 db "  P  N O "
 db "   P  E A"
 db " N  Y  W "
 db "Y E      "
 db " E W  N  "
 db "  A O  E "
 db "O  R    W"

solution
 incbin "sol2.txt"
; db "HROEPWANY"
; db "NAWYHOPRE"
; db "EYPARNWOH"
; db "WOHPNREYA"
; db "ANRHYEOWP"
; db "YPEOWARHN"
; db "REYWAHNPO"
; db "PWANOYHER"
; db "OHNREPYAW"
fnt:incbin "sudoku.fnt"
song: incbin"soundliner-BEFORENY.pt3"
plyr:include "PTxPlay.a80"
wdspr: incbin "wd.bin"
end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "sny.code",begin,end-begin
